#ifndef _COM_H_
#define _COM_H_

#ifdef _WIN32
#include <winsock.h>						
#endif

// Fehler
#define ERR_NO			0	// kein Fehler
#define ERR_COM_OPEN	1	// Serielle Schnitstelle kann nicht geffnet werden
#define ERR_NO_COM		2	// Gert antwortet nicht
#define ERR_WRITE		3	// Fehler beim schreiben in Gert
#define ERR_READ		4	// Fehler beim lesen aus Gert
#define ERR_FILE_OPEN	5	// File fr Ablage der Daten kann nicht geffnet werden
#define ERR_CRC			6	// CRC-Fehler beim lesen der Daten aus Gert
#define ERR_ADD_SE		7	// Fehler bei Sender-/Empfnger Adresse
#define ERR_BEFEHL_S4	8
#define ERR_FORMAT		10	// Datensatz-Format falsch im  TB
#define ERR_ABBRUCH		12	// Daten lesen von Anwender abgebrochen weil Datei bereits vorhenden
#define ERR_UNBEKANNT	13
#define ERR_DAT_WRITE	14	// Schreibbefehl wurde von Gert nicht akzeptiert
#define ERR_WRITE_CNT	15	// Anzahl der geschriebenen Byte zu klein
#define ERR_BEDIEN_STOP	16	// Bedienung kann nicht angehalten werden
#define ERR_TYP_UNBEKANNT	17	// Typ der Kommunikation Schicht 2 unbekannt

#define ERR_PAKET_LENGTH 18 // Paketlaenge ueber-/unterschritten

// Parameter der Kommunikation Applikationsschicht
#define A_MAX_DATEN		255	// max. Datenbyte in einem Paket 
#define A_VERSUCHE		4	// Anzahl Versuche ein Paket zu verschicken
#define A_VERSUCHE_OMB	2	// Anzahl Versuche ein Paket zu verschicken OldMB

// Parameter der Verbindungsschicht
#define V_MAX_PAKET	0x600	// max. Anzahl Byte eines kompletten Pakets
#define V_KOPF		9		// Paketkopf in Byte (endet mit Time to live)
#define V_O_AD_EMPFAENGER 0	// Offsets innerhalb des Pakets
#define V_O_AD_ABSENDER_S2	2	// Schicht 2
#define V_O_LAENGE	4
#define V_O_B_S2	6	// Befehl Schicht 2
#define V_O_PAKET_NR 7
#define V_O_TIME_TO_LIVE 8
#define V_O_B_S3	9	// Befehl Schicht 3
#define V_O_ANZ_BLOECKE 10
#define V_O_AKT_BLOCK	11
#define V_O_AD_ABSENDER_S4	12	// Schicht 4 
#define V_O_B_S4	14
#define V_O_ADD		15
#define V_O_DATEN	19

#define MAX_REMOTE_IP	0x200	// Anzahl Byte max. fr Remote IP

/* Addresscodes Kommunikation (MSB der Adresse welches Sonderfunktionen
auslst) */
#define MBAC_FLASH        0x40    /* Flash lesen schreiben               */
#define MBAC_VERSION      0x41    /* Hard-/Software Version abfragen     */
#define MBAC_BEDIEN       0x42    /* Bedienung anhalten / fortsetzen     */
#define MBAC_TIME         0x43    /* Uhrzeit stellen                     */
#define MBAC_DATENSATZ    0x44    /* Datensatz lesen / lschen           */
#define MBAC_KONFIG       0x45    /* Konfiguration Docon                 */
#define MBAC_KONFIGBEDIEN 0x46    /* Konfiguration Bedienung (Strukturen)*/
#define MBAC_LISTEN       0x47    /* Speicherbereich fr Listen          */
#define MBAC_TEXTE        0x48    /* Speicherbereich fr Texte, Sprachen */
#define MBAC_DATSPEICHER  0x49    /* Speicher Datenstze fr Tests       */
//#define MBAC_TEXTE        0x4A    /* Downloadbereich fr Firmware        */
#define MBAC_POINTER      0x4B    /* Pointer Ringspeicher fr Tests      */

// Schicht 2
#define P_S2_TIME_TO_LIVE	5	// Init-Wert fr Time to live
//		Befehle
#define B_S2_NO					0x01	// keine besondere Bedeutung
#define B_S2_EMPFAENGER_TABELLE	0x02
//		Typen
#define T_S2_RS232		1	// RS232 direkt
#define T_S2_BIM_DIREKT	2	// Funk mit BIM2 ber Umsetzer ohne eigenen Controller
#define T_S2_TCP_IP		3	// TCP/IP

// Befehle Schicht 3
#define B_S3_NO					0x01	// keine besondere Bedeutung
// Befehle Schicht 3
#define B_S4_LESEN				0x01	// Daten lesen
#define B_S4_SCHREIBEN			0x02	// Daten schreiben
//		Bits im Befehl
#define BB_S4_ANTWORT			0x80	// Antwort auf Befehl
#define BB_S4_ANFRAGE			0x40	// Antwort gewnscht

// Datensatzaufbau
#define DAT_START_CHAR 0x02	// Startzeichen fr den Datensatz
							// entspricht bei ASCII DIN66003 STX -> Anfang des Textes 
#define DAT_END_CHAR 0x03	// Endezeichen fr den Datensatz

#ifdef DOCON_SETUP
#define MAX_DATENSATZ 0x200	// Anzahl Zeichen fr einen Datensatz
#define MAX_FELD	41	 // Anzahl Zeichen fr ein Datensatzfeld incl. abschliesende '\0'
#endif

// Timeout fr Antwort von Gert
#define  COM_TIMEOUT		1000

// Funk
#define LEN_PREAMBLE            30

#define ZEICHEN_PREAMBLE        0x55
#define ZEICHEN_SYNCHRO         0xFF
#define ZEICHEN_START           0xAA

#define MAX_FUNK_BUFFER			0x500

#define FUNK_BAUD	9600

#define LLM_WARTESEND_PAKET     42             // (42)
#define LLM_PREAMBLES_START     LLM_WARTESEND_PAKET     + 1             // (43)
#define LLM_PREAMBLES_END       LLM_PREAMBLES_START     + LEN_PREAMBLE  // (73)
#define LLM_SEND_SYNCHRO1       LLM_PREAMBLES_END       + 1             // (74)
#define LLM_SEND_SYNCHRO2       LLM_SEND_SYNCHRO1       + 1             // (75)
#define LLM_SEND_START          LLM_SEND_SYNCHRO2       + 1             // (76)
#define LLM_SEND_PAKET          LLM_SEND_START          + 1             // (77)
#define LLM_WARTE_PREAMBLE      LLM_SEND_PAKET          + 1             // (78)
#define LLM_PREAMBLE_W1         LLM_WARTE_PREAMBLE      + 1             // (79)
#define LLM_WARTE_START         LLM_PREAMBLE_W1         + 1             // (80)
#define LLM_WARTE_EMPF          LLM_WARTE_START         + 1             // (81)
#define LLM_EMPF_PAKET          LLM_WARTE_EMPF          + 1             // (82)

#define ANZ_ERRORZEICHEN    3       /* max. 3 falsche Zeichen zwischen Prambel und Start */
#define MAX_WARTEN_START	1400		/* nach Anfrage mu Slave nach dieser Zeichenzahl Startzeichen geschickt haben */

union U_intbyte
{
   int   IntWert     ;
   unsigned short  WortWert    ;
   unsigned char  ByteWert[2];
   unsigned char EditWert[2];
};


class CCom
{
public:
	volatile char ComPort[64];
	volatile int Baud;
	volatile int ComOpenFlag;
	volatile int AdAbsender;
	volatile int Typ;
	volatile int TimeToLive;
	int ComTimeOut;
	HANDLE hcom;
	SOCKET Socket;         // Handle TCP_Socket Schnittstelle
	unsigned char SBuf[V_MAX_PAKET];	// Buffer fr Pakete
	unsigned char EBuf[V_MAX_PAKET]; 
	unsigned char PaketNr;	// Fortlaufende Paketnummer Schicht 2
	char RemoteIP[MAX_REMOTE_IP];
	int PortNo;

	CCom();
	CCom(int Typ, char *szComPort,int ComValue, unsigned short Absender);
	~CCom();

	// Grundeinstellungen (Aufruf z.B. nach Fehler waehrend Schnittstelleninitialisierung)
	void SetDefault();

	int ComOpen();
	void ComClose();

	/// Setzen des Logdateinamen.
	inline void SetLogFileName(const char *szLogFileName)
	{ strcpy(LogDateiName, (const char*)szLogFileName); }
	
	/// Log anschalten.
	inline void SetLogOn()  
	{ LogIsOn = true; }
	
	/// Log ausschalten.
	inline void SetLogOff() 
	{ LogIsOn = false; }

	// evtl. anstehende Daten verwerfen.
	void ClearCom();

	// Zeiger auf Rueckruffunktion setzen
	void SetCallBack(int (*CBFunction)(void));

	int ReadMem(unsigned short AdEmpfaenger, unsigned long Add, int Cnt, unsigned char *Buf, int *Err);
	int WriteMem(unsigned short AdEmpfaenger, unsigned long Add, int Cnt, unsigned char *Buf, int *Err);

	int OldMB(unsigned short AdEmpfaenger,unsigned char *buf, int *Len, int *Err);
	int Command(unsigned char *sbuf,int cnt,unsigned char *ebuf,int &ret, int *Err);

protected:
	bool LogIsOn;
	char LogDateiName[MAX_PATH];
	int (*CBFunction)(void);
	void ComLog(const char *Format, ...);

public:
	int WriteMemPaket(unsigned short AdEmpfaenger, unsigned long Add, int Cnt, unsigned char *Buf, int *Err);
	int ReadMemPaket(unsigned short AdEmpfaenger, unsigned long Add, int &Cnt, unsigned char *Buf, int *Err);

protected:
	void UShortToBin(unsigned short Val,unsigned char *Buf);	
	void ULongToBin(unsigned long Val,unsigned char *Buf);	
	unsigned short BinToUShort(unsigned char *Buf);	
	unsigned long BinToULong(unsigned char *Buf);	

	void MkPaketCrc(unsigned char *buf,int cnt);
	int CheckPaketCrc(unsigned char *buf, int cnt);
	
	int ExeCallBack();
	int CommandRsTcp(unsigned char *sbuf,int cnt,unsigned char *ebuf,int &ret, int *Err);

#ifdef _WIN32
	int CommandBimDirekt(unsigned char *sbuf,int cnt,unsigned char *ebuf,int &ret, int *Err);
	int SetComTimeout(int TimeOutMS);

	int MkTxdBufferFunk(unsigned char *sbuf,int cnt,unsigned char *FunkBuf);
	void ASCII_to_diphase(unsigned char Zeichen, unsigned char *Pointer_String);
	unsigned char diphase_to_ASCII (unsigned char *Pointer_String);
#endif

	int SerialOpen(char *szComPort, int iBaudRate, int iTimeOut);
public:
	int SetSerialComState(HANDLE hComPort, int iBaudRate, int iTimeOut);
protected:
	void SerialClose(void);

	int SocketOpen(char *RemoteIP, int PortNo, long TimeOut);
	void SocketClose(void);

	// Lesen
public:
	int Read(void *pBuf, int iLength, unsigned long *pdwReadLen);
protected:
	int SerialRead(char *pcInputBuf, int iInputLen, unsigned long *pdwReadLen);
	int SocketRead(char *InputBuf, int InputLen, unsigned long *ReadLen);

	// Schreiben
public:
	int Write(void *pBuf, int iLength, unsigned long *pdwWriteLen);
protected:
	int SerialWrite(const char *pcOutputBuf, int iOutputLen, unsigned long *pdwWriteLen);
	int SocketWrite(const char *OutputBuf, int OutputLen, unsigned long *WriteLen);

private:
#ifndef _WIN32
	struct termio termio_s;
	struct flock  flock_s;
#endif
};

#endif
