#ifndef _EXTENDED_FLASH_H_
#define _EXTENDED_FLASH_H_

// ########################################################
// Erweiterter Flash

#define EXTENDED_CHECK		0xAAAAAAAE

typedef struct StructAE3Extended {
	ULONG ulCheck;		// muss immer mit 0xAAAAAAAA belegt werden.
	ULONG ulSize;		// groesse der Stuktur sizeof(TAE3Extended)
	ULONG pulIOModule;	// Zeiger auf IOModul - Struktur
	ULONG pulIODigital; // Zeiger auf die 8 TAE3DigitalMDE - Strukturen des IOModul
	ULONG pulMDEDigital; // Zeiger auf die 4 TAE3DigitalMDE - Strukturen fuer intern.
	ULONG pulEKArray;	// Zeiger auf PointerArray der Eingabeketten fuer MDE
	ULONG pulFreeScope;	// Zeiger auf naechsten freien Speicherbereich im ExtendedFlashMem
	ULONG pulEntranceTables; // Tabellen fuer Zutrittskontrolle
	ULONG pulEKArrayEntrance;// Zeiger auf PointerArray der Eingabeketten fuer Zutrittskontrolle
	ULONG pulValueGVx;  // Zeiger auf Struktur mit Standardwerten der GVs
	UCHAR tmp[56];		// auf 100 Byte Strukturgroesse bringen.
	ULONG ulFlags;      // Flags fuer Struktur und Erweiterten Speicher
} TAE3Extended;

// EXTendedFlag fuer Struktur
#define EXTF_EMPTY           0x00000000  // Nicht vorhanden
#define EXTF_NEW             0x00000001  // Struktur angelegt
#define EXTF_DOWNLOAD        0x00000010  // Aus geraet ausgelesene Daten

// Maximalanzahl des Einheitssuffix mit 0 terminie.
#define MAX_UNIT_TXT	5

// Struktur fuer IO-Modul
typedef struct StructAE3IOModule {
	
	//Spannungseingaenge
	UCHAR ucActiveU;                  // Flags welcher Eingang aktiv.
	UCHAR szNameU[8][MAX_S_FELD_TXT]; // Bezeichner der Eingaenge
	float fMinU[8];					  // Minimalwert fuer Berechnung
	float fMaxU[8];					  // Maximalwert fuer Berechnung
	UCHAR szUnitU[8][MAX_UNIT_TXT];	  // Einheit - suffix der Berechnung.
	UCHAR ucOnScreenU;                // Flags ob Ausgabe auf Display erlaubt.

	// Stromeingaenge
	UCHAR ucActiveI;
	UCHAR szNameI[8][MAX_S_FELD_TXT];
	float fMinI[8];
	float fMaxI[8];
	UCHAR szUnitI[8][MAX_UNIT_TXT];
	UCHAR ucOnScreenI;

} TAE3IOModule;


// Struktur fuer Digitale Eingaenge
typedef struct StructDigitalMDE {

	UCHAR ucUseAs;
	UCHAR ucStartLowHigh;
	UCHAR ucStartHighLow;
	unsigned short uiCountDivisor;
	unsigned short uiCycle;
	unsigned short uiTimeOut;

	UCHAR ucTmp[12];

} TAE3DigitalMDE;

// Standardwerte fuer Globale Variable
typedef struct StructValueGVx {
	UCHAR ucFlags;                   // Bitfeld fuer Variablenflag "setzen".
	UCHAR szValue[8][MAX_DATEN_LEN]; // Zu setzender Wert.
} TValueGVx;

#endif

