Attribute VB_Name = "DFCommon"
Option Explicit
' ACHTUNG: InitModul zur Initialisierung aufrufen
' #######################
' Constructor: B.Ottmann
' #######################

' Dies ist das Zentrale Kommunikationsmodul
'
'
'
'
'
' Speichert Dateiname der verwendeten Initialisierungsdatei
Private IniFileName As String

' Lesen aus einem Profile oder schreiben in ein Profile
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
 
' Connect
Public IsConnect As Boolean        ' Com geoeffnet
Public Message As String           ' Halten des Messagetextes
Public MessageTime As Long
Public MessageAction As Long
Public MessageAudio As Long

Public CurrentDS As Long
Public CurrentField As Long

Public CurrentLS As Long
Public CurrentListField As Long

Public TmpNumber As Long

Public Const Flags_TransmitConfig  As Long = cdlOFNFileMustExist

' Um die Buttons ein oder aus zu schalten
' Speichert ob bereits daten geladen wurden und vorhanden sind
Public IsDaten As Boolean
' Speichert ob bereits die Datensatzbeschreibung geladen wurde
Public IsDatensatzbeschreibung As Boolean
' Speichert ob bereits die Listenbeschreibung geladen wurde
Public IsListenbeschreibung As Boolean
' Praefix fuer Infozeilen
Public m_strDatensatzIst As String

' Initialisieren der Variablen mit Werten
Public Sub InitModul()
    ' Fuer Connect von AEIII+
    IsConnect = False
    Message = "?"
    MessageTime = 255  ' Action von Bediener erforderlich
    MessageAction = 0  ' normal weiter
    MessageAudio = 1   ' einfach piep
    
    ' Initdatei fuer die Application des Moduls als default
    IniFileName = App.Path & "\dfcomvb.ini"
    
    CurrentDS = 0
    CurrentField = 0
    
    CurrentLS = 0
    CurrentListField = 0
    
    TmpNumber = -1
End Sub

' Initialisierung extendet
Public Function GetIniFile() As String
    GetIniFile = IniFileName
End Function

Public Sub SetIniFile(newIniFileName As String)
    IniFileName = newIniFileName
End Sub

' Schreiben und lesen aus Inifile
Public Function WriteProfileStr(SectionName As String, KeyName As String, strString As String) As Long
    WriteProfileStr = WritePrivateProfileString(SectionName, KeyName, strString, IniFileName)
End Function

Public Function GetProfileStr(SectionName As String, KeyName As String, strDefault As String, ReturnedString As String, Size As Long) As Long
    GetProfileStr = GetPrivateProfileString(SectionName, KeyName, strDefault, ReturnedString, Size, IniFileName)
End Function

Public Function GetProfileInt(SectionName As String, KeyName As String, Default As Long) As Long
    GetProfileInt = GetPrivateProfileInt(SectionName, KeyName, Default, IniFileName)
End Function

' Ausgabe einer aufgeloesten Fehlermeldung
Public Sub ErrorMsg(msgNo As Long)
    Dim ComNum As Long
    Dim strMsg As String * 256
    
    ComNum = frmHaupt.lstCom.ListIndex + 1
    
    Call DFCGetErrorText(ComNum, msgNo, 0, strMsg, 256)
    
    MsgBox "Error: " & CStr(msgNo) & vbCrLf & _
    "Ist: " & strMsg, vbCritical, DeviceString & " Error"
End Sub

' Die daten der verschiedenen Feldtypen in Textketten umwandeln
Public Function ConvertToText(daten As String, Typ As Long) As String
    ' Variable fuer Datumstyp
    Dim Jahrhundert As String
    Dim Jahr As String
    Dim Monat As String
    Dim Tag As String
    ' Variable fuer Zeit
    Dim Stunde As String
    Dim Minute As String
    Dim Sekunde As String
    
    Select Case Typ
    Case 1 ' TypeDescription = "1-> unsigned long 4 Byte"
        Dim valflow@ ' as Currency 64bit
        ' Die Bytes muessen wegen MSBFirst gedreht 3<->0 und das
        ' Ergebnis ULong welches als Long in valflow interpretiert wird
        ' in Unsigned gewandelt werden.
        Dim bit As Byte
        Dim bytes(3) As Byte
        bytes(3) = AscB(Mid(daten, 1, 1))
        bytes(2) = AscB(Mid(daten, 2, 1))
        bytes(1) = AscB(Mid(daten, 3, 1))
        bytes(0) = AscB(Mid(daten, 4, 1))
        ' Alles geht natuerlich auch irgentwie anders, aber hier
        ' ist das wenigstens ne sichere Sache, oder ?
        For bit = 0 To 31
            Select Case bit
            Case 0 To 7 ' Erstes Byte 1 zu 1 uebernehmen
            If (bytes(0) And 2 ^ bit) <> 0 Then
                valflow = valflow Or 2 ^ bit
            End If
            Case 8 To 15 ' Mit allen anderen auch
            If (bytes(1) And 2 ^ (bit - 8)) <> 0 Then
                valflow = valflow Or 2 ^ bit
            End If
            Case 16 To 23
            If (bytes(2) And 2 ^ (bit - 16)) <> 0 Then
                valflow = valflow Or 2 ^ bit
            End If
            Case 24 To 30
            If (bytes(3) And 2 ^ (bit - 24)) <> 0 Then
                valflow = valflow Or 2 ^ bit
            End If
            Case 31
                   ' Uebertrag abfangen
            If (bytes(3) And &H80) <> 0 Then
                valflow = valflow Or &H80000000
            End If
            End Select
        Next bit
        ' signed to unsigned
        If valflow < 0 Then
            valflow = valflow + 2 ^ 32
        End If
        ' Zahl mit Zehn stellen abbilden
        ConvertToText = Format(valflow, "#########0")
    
    Case 2 ' TypeDescription = "2-> Datum und Zeit 7 Byte (4 Byte Datum 3 Byte Zeit)"
        ' Auffuellen des Datums und der Uhrzeit getrennt durch Tab zurueckgeben
        ' Datum aus Buffer ermitteln
        Jahrhundert = Format(Asc(Mid(daten, 1, 1)), "00")
        Jahr = Format(Asc(Mid(daten, 2, 1)), "00")
        Monat = Format(Asc(Mid(daten, 3, 1)), "00")
        Tag = Format(Asc(Mid(daten, 4, 1)), "00")
        ' Uhrzeit aus Buffer ermitteln
        Stunde = Format(Asc(Mid(daten, 5, 1)), "00")
        Minute = Format(Asc(Mid(daten, 6, 1)), "00")
        Sekunde = Format(Asc(Mid(daten, 7, 1)), "00")
        ConvertToText = Tag & "." & Monat & "." & Jahrhundert & Jahr & " " & Stunde & ":" & Minute & ":" & Sekunde
    
    Case 3 ' TypeDescription = "3-> wie Typ (Alpha-Numerisch ASCII) jedoch nur Ziffern erlaubt"
        'ConvertToText = Left(daten, InStr(1, daten, Chr(0)) - 1)
        ConvertToText = Format(daten, String(Len(daten), "#"))
    
    Case 4 ' TypeDescription = "4-> Alpha-Numerisch ASCII"
        ConvertToText = Left(daten, InStr(1, daten, Chr(0)) - 1)
    
    Case 5 ' TypeDescription = "5-> Datum 4 Byte Y100,Y,M,D"
        ' Datum aus Buffer ermitteln
        Jahrhundert = Format(Asc(Mid(daten, 1, 1)), "00")
        Jahr = Format(Asc(Mid(daten, 2, 1)), "00")
        Monat = Format(Asc(Mid(daten, 3, 1)), "00")
        Tag = Format(Asc(Mid(daten, 4, 1)), "00")
        ConvertToText = Jahrhundert & "-" & Jahr & "-" & Monat & "-" & Tag
    
    Case 6 ' TypeDescription = "6-> Zeit 3 Byte H,M,S"
        ' Uhrzeit aus Buffer ermitteln
        Stunde = Format(Asc(Mid(daten, 1, 1)), "00")
        Minute = Format(Asc(Mid(daten, 2, 1)), "00")
        Sekunde = Format(Asc(Mid(daten, 3, 1)), "00")
        ConvertToText = Stunde & ":" & Minute & ":" & Sekunde
    
    Case Else
        ConvertToText = ""
    End Select
End Function
